package com.huimv.env.common.dao.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.persistence.*;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 
 * </p>
 *
 * @author author
 * @since 2022-10-11
 */
@Data
@Accessors(chain = true)
@Table(name = "env_electricity_meter")
@Entity
public class EnvElectricityMeter implements Serializable {

    private static final long serialVersionUID = 1L;



    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    private Integer id;

    @Column(name = "device_code")
    private String deviceCode;

    @Column(name = "sensor_sn")
    private Integer sensorSn;

    @Column(name = "electricity_meter")
    private BigDecimal electricityMeter;

    @Column(name = "ask_time")
    private String askTime;

    @Column(name = "add_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date addTime;

    @Column(name = "add_date")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date addDate;

    @Column(name = "pigpen_id")
    private String pigpenId;

    @Column(name = "unit_id")
    private String unitId;

    @Column(name = "farm_code")
    private String farmCode;

    @Column(name = "data_unit")
    private String dataUnit;

    @Column(name = "electricity_meter_data")
    private Integer electricityMeterData;


    public EnvElectricityMeter(Integer id, String deviceCode, Integer sensorSn, BigDecimal electricityMeter, String askTime, Date addTime, Date addDate, String pigpenId, String unitId, String farmCode, String dataUnit, Integer electricityMeterData) {
        this.id = id;
        this.deviceCode = deviceCode;
        this.sensorSn = sensorSn;
        this.electricityMeter = electricityMeter;
        this.askTime = askTime;
        this.addTime = addTime;
        this.addDate = addDate;
        this.pigpenId = pigpenId;
        this.unitId = unitId;
        this.farmCode = farmCode;
        this.dataUnit = dataUnit;
        this.electricityMeterData = electricityMeterData;
    }

    public EnvElectricityMeter() {
    }
}
