package com.huimv.env.common.service.impl;

import com.huimv.env.common.dao.entity.EnvDeviceRegisterEntity;
import com.huimv.env.common.dao.repo.EnvDeviceRegisterEntityRepo;
import com.huimv.env.common.service.IDeviceRegisterService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Optional;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
@Slf4j
public class DeviceRegisterServiceImpl implements IDeviceRegisterService {
    @Autowired
    private EnvDeviceRegisterEntityRepo envDeviceRegisterEntityRepo;

    @Override
    public String getDeviceCodeByChipId(String chipId){
        //
        Optional<EnvDeviceRegisterEntity> optional = envDeviceRegisterEntityRepo.getDeviceRegisterByChipId(chipId);
        if(!optional.isPresent()){
            log.error("该设备[芯片id:"+chipId+"]未注册.");
            return null;
        }else{
            return optional.get().getDeviceCode();
        }
    }

    @Override
    public boolean isExistByDeviceCode(String deviceCode) {
        //
        Optional<EnvDeviceRegisterEntity> optional =  envDeviceRegisterEntityRepo.getDeviceRegisterByDeviceCode(deviceCode);
        if(!optional.isPresent()){
            log.error("该设备[设备编码:"+deviceCode+"]未注册.");
            return false;
        }else{
            return true;
        }
    }

    @Override
    public String getFarmCodeByDeviceCode(String deviceCode){
        //
        Optional<EnvDeviceRegisterEntity> optional =  envDeviceRegisterEntityRepo.getDeviceRegisterByDeviceCode(deviceCode);
        if(!optional.isPresent()){
            log.error("该设备[设备编码:"+deviceCode+"]未注册.");
            return null;
        }else{
            return optional.get().getFarmCode();
        }
    }

    @Override
    public EnvDeviceRegisterEntity getDeviceRegisterByDeviceCode(String deviceCode){
        //
        Optional<EnvDeviceRegisterEntity> optional =  envDeviceRegisterEntityRepo.getDeviceRegisterByDeviceCode(deviceCode);
        if(!optional.isPresent()){
            log.error("该设备[设备编码:"+deviceCode+"]未注册.");
            return null;
        }else{
            return optional.get();
        }
    }
}
