package com.huimv.env.common.service.impl;

import com.huimv.env.common.dao.repo.BasePigpenEntityRepo;
import com.huimv.env.common.service.IPigpenService;
import org.junit.platform.commons.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
public class PigpenServiceImpl implements IPigpenService {
    @Autowired
    private BasePigpenEntityRepo basePigpenRepo;

    @Override
    public String getPigpenByDevice(String device) {
        //根据设备读取栋舍
        List<Object[]> pigpenList = basePigpenRepo.getPigpenByDevice(device);
        if(pigpenList.size()==0){
            return "";
        }else{
            StringBuilder sb = new StringBuilder();
            for(int a=0;a<pigpenList.size();a++){
                Object[] objArray = pigpenList.get(0);
//                sb.append(objArray[0]).append(",").append(objArray[1]);
                // 栋舍
                if(objArray[0] != null){
                    if(sb.length()>0){
                        sb.append(",");
                    }
                    sb.append(objArray[0]);
                }
                //单元
                if(objArray[1] != null){
                    if(sb.length()>0){
                        sb.append(",");
                    }
                    sb.append(objArray[1]);
                }
            }
            return sb.toString();
        }
    }
}
