package com.huimv.env.common.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.huimv.env.common.dao.entity.EnvDeviceRegisterEntity;
import com.huimv.env.common.dao.entity.EnvSprayConfigEntity;
import com.huimv.env.common.dao.repo.EnvSprayConfigEntityRepo;
import com.huimv.env.common.service.ISprayConfigService;
import com.huimv.env.common.service.ISprayStatusService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import java.sql.Date;
import java.sql.Timestamp;
import java.util.Optional;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
public class SprayConfigServiceImpl implements ISprayConfigService {
    @Autowired
    private EnvSprayConfigEntityRepo sprayConfigEntityRepo;

    @Override
    public JSONObject getSprayConfigByDeviceCode(String deviceCode,String farmCode) {
        EnvSprayConfigEntity envSprayConfigEntity = new EnvSprayConfigEntity();
        envSprayConfigEntity.setDeviceCode(deviceCode);
        envSprayConfigEntity.setFarmCode(farmCode);
        Example<EnvSprayConfigEntity> example = Example.of(envSprayConfigEntity);
        Optional<EnvSprayConfigEntity> option =  sprayConfigEntityRepo.findOne(example);
        if(!option.isPresent()){
            return null;
        }else{
            return JSONObject.parseObject(JSON.toJSONString(option.get()));
        }
    }
}
