package com.huimv.env.common.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.huimv.env.common.dao.entity.EnvDeviceRegisterEntity;
import com.huimv.env.common.dao.entity.EnvSprayConfigEntity;
import com.huimv.env.common.dao.entity.EnvSprayStatusEntity;
import com.huimv.env.common.dao.repo.EnvSprayConfigEntityRepo;
import com.huimv.env.common.dao.repo.EnvSprayStatusEntityRepo;
import com.huimv.env.common.service.ISprayStatusService;
import com.huimv.env.common.utils.DateUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import java.sql.Date;
import java.sql.Timestamp;
import java.util.Optional;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
@Slf4j
public class SprayStatusServiceImpl implements ISprayStatusService {
    @Autowired
    private EnvSprayStatusEntityRepo sprayStatusEntityRepo;
    @Autowired
    private EnvSprayConfigEntityRepo envSprayConfigEntityRepo;
    @Autowired
    private DateUtil dateUtil;

    @Override
    public void saveSprayStatusFlow(JSONObject dataJo, EnvDeviceRegisterEntity envDeviceRegisterEntity, Timestamp nowTimestamp, Date todayDate, String farmCode) {
        EnvSprayStatusEntity envSprayStatusEntity = new EnvSprayStatusEntity();
        envSprayStatusEntity.setDeviceCode(dataJo.getString("deviceCode"));
        envSprayStatusEntity.setDeviceStatus(dataJo.getInteger("sprayStatus"));
        envSprayStatusEntity.setAskTime(dateUtil.handleAskTime(dataJo.getString("askTime")));
        envSprayStatusEntity.setAddTime(nowTimestamp);
        envSprayStatusEntity.setAddDate(todayDate);
        envSprayStatusEntity.setPigpenId(envDeviceRegisterEntity.getPigpenId());
        envSprayStatusEntity.setUnitId(envDeviceRegisterEntity.getUnitId());
        envSprayStatusEntity.setFarmCode(farmCode);
        sprayStatusEntityRepo.saveAndFlush(envSprayStatusEntity);
        log.info("保存喷雾设备状态信息流水.");
        //更新设备状态
        EnvSprayConfigEntity envSprayConfigEntity = new EnvSprayConfigEntity();
        envSprayConfigEntity.setDeviceCode(dataJo.getString("deviceCode"));
        envSprayConfigEntity.setFarmCode(farmCode);
        Example<EnvSprayConfigEntity> example = Example.of(envSprayConfigEntity);
        Optional<EnvSprayConfigEntity> optional = envSprayConfigEntityRepo.findOne(example);
        if(!optional.isPresent()){
            log.error("该设备["+dataJo.getString("deviceCode")+"]未配置属性信息.");
            return;
        }else{
            EnvSprayConfigEntity queryEnvSprayConfigEntity = optional.get();
            queryEnvSprayConfigEntity.setOpenStatus(dataJo.getInteger("sprayStatus"));
            queryEnvSprayConfigEntity.setAddTime(nowTimestamp);
            envSprayConfigEntityRepo.saveAndFlush(queryEnvSprayConfigEntity);
            log.info("更新喷雾设备状态信息.");
        }

    }
}
