package com.huimv.env.common.service.impl;

import com.huimv.env.common.dao.entity.EnvSprayTimeEntity;
import com.huimv.env.common.dao.repo.EnvSprayTimeEntityRepo;
import com.huimv.env.common.service.ISprayTimeService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import javax.swing.text.html.Option;
import javax.xml.ws.ServiceMode;
import java.util.List;
import java.util.Optional;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
@Slf4j
public class SprayTimeServiceImpl implements ISprayTimeService {
    @Autowired
    private EnvSprayTimeEntityRepo envSprayTimeEntityRepo;

    @Override
    public String getSprayTimeByDeviceCode(String deviceCode) {
        EnvSprayTimeEntity envSprayTimeEntity = new EnvSprayTimeEntity();
        envSprayTimeEntity.setDeviceCode(deviceCode);
        Example<EnvSprayTimeEntity> example = Example.of(envSprayTimeEntity);
        List<EnvSprayTimeEntity> envSprayTimeEntityList = envSprayTimeEntityRepo.findAll(example);
        StringBuilder timeBuilder = new StringBuilder();
        int a=0;
        for(EnvSprayTimeEntity sprayTimeEntity:envSprayTimeEntityList){
            //开始时间(分秒)
            if(sprayTimeEntity.getOpenTime() != null && sprayTimeEntity.getOpenTime().trim().length() > 0){
                if(timeBuilder.length()>0){
                    timeBuilder.append(",");
                }
                String[] sprayTimeArray = sprayTimeEntity.getOpenTime().split(":");
                timeBuilder.append(sprayTimeArray[0]+sprayTimeArray[1]);
            }else{
                log.error("开始时间[open_time]为null或为空.");
            }
            //持续时间
//            if(sprayTimeEntity.getDuration() != null && sprayTimeEntity.getDuration() > 0){
//                if(timeBuilder.length()>0){
//                    timeBuilder.append(",");
//                }
//                timeBuilder.append(sprayTimeEntity.getDuration());
//            }else{
//                log.error("持续时间为null或为空.");
//            }
            //结束时间
            if(sprayTimeEntity.getCloseTime()!= null && sprayTimeEntity.getCloseTime().trim().length() > 0){
                if(timeBuilder.length()>0){
                    timeBuilder.append(",");
                }
                String[] closeTimeArray = sprayTimeEntity.getCloseTime().split(":");
                timeBuilder.append(closeTimeArray[0]+closeTimeArray[1]);
            }else{
                log.error("结束时间[close_time]为null或为空.");
            }
            //开关时长
            if(sprayTimeEntity.getOpenMode() != null && sprayTimeEntity.getOpenMode().trim().length() > 0){
                if(timeBuilder.length()>0){
                    timeBuilder.append(",");
                }
                String openMode = sprayTimeEntity.getOpenMode();
                String[] openModeArray = openMode.split(",");
                //分钟-->秒钟
                timeBuilder.append(String.valueOf(Integer.parseInt(openModeArray[0])*60)+","+String.valueOf(Integer.parseInt(openModeArray[1])*60));
            }else{
                log.error("开始时长为null或为空.");
            }
        }
        System.out.println("timeBuilder.toString()="+timeBuilder.toString());
        return timeBuilder.toString();
    }
}
