package com.huimv.env.device.listener;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.huimv.env.common.service.ISensorRegisterService;
import com.huimv.env.common.utils.Const;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.annotation.RabbitHandler;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.sql.Timestamp;
import java.text.ParseException;
import java.util.Date;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
@Slf4j
public class SensorListener {
    @Autowired
    private ISensorRegisterService sensorRegisterService;

//    @RabbitListener(queues = Const.QUEUE_SENSOR)
    @RabbitHandler
    public void processTemp(Map RawMap) throws ParseException {
        System.out.println(">>>>>>接收传感器数据 RawMap>>" + RawMap.toString());
        JSONObject sensorJo = JSON.parseObject(RawMap.get("sensor").toString());
        String deviceCode = sensorJo.getString("deviceCode");
        int sensorSn = sensorJo.getInteger("sensorSn");
        int sensorSort = sensorJo.getInteger("sensorSort");
        String farmCode = sensorJo.getString("farmCode");
        Timestamp nowTimestamp = sensorJo.getTimestamp("timestamp");
        java.sql.Date todayDate = new java.sql.Date(sensorJo.getDate("todayDate").getTime());
        String value = sensorJo.getString("value");
        if (sensorRegisterService.isExistSensorRegister(deviceCode, sensorSn, farmCode,sensorSort)) {
            //{更新传感器注册信息}
            sensorRegisterService.updateSensorRegister(deviceCode, sensorSn, nowTimestamp, todayDate, value, farmCode,sensorSort);
        } else {
            //{保存传感器注册信息}
            sensorRegisterService.saveSensorRegister(deviceCode, sensorSn, nowTimestamp, todayDate, value, farmCode,sensorSort);
        }
    }
}
