package com.huimv.env.device.producer;

import com.alibaba.fastjson.JSONObject;
import com.huimv.env.common.utils.Const;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
@Slf4j
public class Producer {
    @Autowired
    RabbitTemplate rabbitTemplate;  //使用RabbitTemplate,这提供了接收/发送等等方法

    /**
     * @Method      : sendTempAskToMQ
     * @Description : 
     * @Params      : [askText]
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/8/17       
     * @Time        : 19:29
     */
    public String sendSensorAskToMQ(JSONObject sensorJo){
        Map map = new HashMap();
        map.put("sensor",sensorJo);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_SENSOR, Const.ROUTING_KEY_SENSOR, map);
        return "ok";
    }


}
