package com.huimv.env.input;

import com.huimv.env.input.server.EnvInputServer;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.ComponentScans;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@ComponentScans({@ComponentScan("com.huimv.env.common.utils"),
        @ComponentScan("com.huimv.env.common.service")})
@EntityScan(value = "com.huimv.env.common.dao.entity")
@EnableJpaRepositories(basePackages = "com.huimv.env.common.dao.repo")
@MapperScan(basePackages = "com.huimv.env.common.mapper")
@SpringBootApplication
public class HuimvEnvInputApplication {
    public static void main(String[] args) throws InterruptedException {
        ApplicationContext applicationContext = SpringApplication.run(HuimvEnvInputApplication.class, args);
        // EnvInputServer
        applicationContext.getBean(EnvInputServer.class).run();
    }
}
