package com.huimv.env.input.config;

import com.huimv.env.common.utils.Const;
import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.Queue;
import org.springframework.amqp.core.TopicExchange;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Configuration
public class TopicRabbitMQConfig {
    //温度
    @Bean
    public Queue tempQueue() {
        return new Queue(Const.QUEUE_TEMP);
    }
    @Bean
    TopicExchange tempExchange() {
        return new TopicExchange(Const.EXCHANGE_TEMP);
    }
    @Bean
    Binding bindingTempExchangeMessage() {
        return BindingBuilder.bind(tempQueue()).to(tempExchange()).with(Const.ROUTING_KEY_TEMP);
    }

    //湿度
    @Bean
    public Queue humiQueue() {
        return new Queue(Const.QUEUE_HUMI);
    }
    @Bean
    TopicExchange humiExchange() {
        return new TopicExchange(Const.EXCHANGE_HUMI);
    }
    @Bean
    Binding bindingHumiExchangeMessage() {
        return BindingBuilder.bind(humiQueue()).to(humiExchange()).with(Const.ROUTING_KEY_HUMI);
    }

    //氨气
    @Bean
    public Queue ammoniaQueue() {
        return new Queue(Const.QUEUE_AMMONIA);
    }
    @Bean
    TopicExchange ammoniaExchange() {
        return new TopicExchange(Const.EXCHANGE_AMMONIA);
    }
    @Bean
    Binding bindingAmmoniaExchangeMessage() {
        return BindingBuilder.bind(ammoniaQueue()).to(ammoniaExchange()).with(Const.ROUTING_KEY_AMMONIA);
    }

    //传感器
    @Bean
    public Queue sensorQueue() {
        return new Queue(Const.QUEUE_SENSOR);
    }
    @Bean
    TopicExchange sensorExchange() {
        return new TopicExchange(Const.EXCHANGE_SENSOR);
    }
    @Bean
    Binding bindingSensorExchangeMessage() {
        return BindingBuilder.bind(sensorQueue()).to(sensorExchange()).with(Const.ROUTING_KEY_SENSOR);
    }

    //设备状态
    @Bean
    public Queue deviceStatusQueue() {
        return new Queue(Const.QUEUE_DEVICE_STATUS);
    }
    @Bean
    TopicExchange deviceStatusExchange() {
        return new TopicExchange(Const.EXCHANGE_DEVICE_STATUS);
    }
    @Bean
    Binding bindingDeviceStatusExchangeMessage() {
        return BindingBuilder.bind(deviceStatusQueue()).to(deviceStatusExchange()).with(Const.ROUTING_KEY_DEVICE_STATUS);
    }

    //推送短信
    @Bean
    public Queue pushMessageQueue() {
        return new Queue(Const.QUEUE_PUSH_MESSAGE);
    }
    @Bean
    TopicExchange pushMessageExchange() {
        return new TopicExchange(Const.EXCHANGE_PUSH_MESSAGE);
    }
    @Bean
    Binding bindingPushMessageMessage() {
        return BindingBuilder.bind(pushMessageQueue()).to(pushMessageExchange()).with(Const.ROUTING_KEY_PUSH_MESSAGE);
    }
    //推送水压
    @Bean
    public Queue waterGegeQueue() {
        return new Queue(Const.QUEUE_WATER_GEGE);
    }
    @Bean
    TopicExchange waterGegeExchange() {
        return new TopicExchange(Const.EXCHANGE_WATER_GEGE);
    }
    @Bean
    Binding bindingWaterGegeExchangeMessage() {
        return BindingBuilder.bind(waterGegeQueue()).to(waterGegeExchange()).with(Const.ROUTING_KEY_WATER_GEGE);
    }

    //推送PH
    @Bean
    public Queue phGegeQueue() {
        return new Queue(Const.QUEUE_PH);
    }
    @Bean
    TopicExchange phGegeExchange() {
        return new TopicExchange(Const.EXCHANGE_PH);
    }
    @Bean
    Binding bindingPhExchangeMessage() {
        return BindingBuilder.bind(phGegeQueue()).to(phGegeExchange()).with(Const.ROUTING_KEY_PH);
    }

    //推送水表
    @Bean
    public Queue waterMeterQueue() {
        return new Queue(Const.QUEUE_WATER_METER);
    }
    @Bean
    TopicExchange waterMeterExchange() {
        return new TopicExchange(Const.EXCHANGE_WATER_METER);
    }
    @Bean
    Binding bindingwaterMeterExchangeMessage() {
        return BindingBuilder.bind(waterMeterQueue()).to(waterMeterExchange()).with(Const.ROUTING_KEY_WATER_METER);
    }


    //推送电表
    @Bean
    public Queue electricityMeterQueue() {
        return new Queue(Const.QUEUE_ELECTRICITY_METER);
    }
    @Bean
    TopicExchange electricityMeterExchange() {
        return new TopicExchange(Const.EXCHANGE_ELECTRICITY_METER);
    }
    @Bean
    Binding bindingelectricityMeterExchangeMessage() {
        return BindingBuilder.bind(electricityMeterQueue()).to(electricityMeterExchange()).with(Const.ROUTING_KEY_ELECTRICITY_METER);
    }
}
