package com.huimv.env.input.producer;

import com.huimv.env.common.utils.Const;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
@Slf4j
public class Producer {
    @Autowired
    RabbitTemplate rabbitTemplate;  //使用RabbitTemplate,这提供了接收/发送等等方法

    /**
     * @Method      : sendTempAskToMQ
     * @Description : 
     * @Params      : [askText]
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/8/17       
     * @Time        : 19:29
     */
    public String sendTempAskToMQ(String askText){
        Map map = new HashMap();
        map.put("askText",askText);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_TEMP, Const.ROUTING_KEY_TEMP, map);
        return "ok";
    }

    /**
     * @Method      : sendHumiAskToMQ
     * @Description : 
     * @Params      : [askText]
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/8/17       
     * @Time        : 19:13
     */
    public String sendHumiAskToMQ(String askText){
        Map map = new HashMap();
        map.put("askText",askText);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_HUMI, Const.ROUTING_KEY_HUMI, map);
        return "ok";
    }

    /**
     * @Method      : sendAmmoniaAskToMQ
     * @Description : 
     * @Params      : [askText]
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/8/17       
     * @Time        : 19:13
     */
    public String sendAmmoniaAskToMQ(String askText){
        Map map = new HashMap();
        map.put("askText",askText);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_AMMONIA, Const.ROUTING_KEY_AMMONIA, map);
        return "ok";
    }

    /**
     * @Method      : sendSprayEquipStatusToMQ
     * @Description : 
     * @Params      : [askText]
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/8/18       
     * @Time        : 20:51
     */
    public String sendSprayEquipStatusToMQ(String askText) {
        Map map = new HashMap();
        map.put("askText",askText);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_DEVICE_STATUS, Const.ROUTING_KEY_DEVICE_STATUS, map);
        return "ok";
    }

    /**
     * @Method      : sendPushMessageToMQ
     * @Description : 
     * @Params      : [askText]
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/8/18       
     * @Time        : 20:52
     */
    public String sendPushMessageToMQ(String askText) {
        Map map = new HashMap();
        map.put("askText",askText);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_PUSH_MESSAGE, Const.ROUTING_KEY_PUSH_MESSAGE, map);
        return "ok";
    }

    public String sendWaterGege(String askText) {

        Map map = new HashMap();
        map.put("askText",askText);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_WATER_GEGE, Const.ROUTING_KEY_WATER_GEGE, map);
        return "ok";
    }

    public String sendPHGege(String askText) {
        Map map = new HashMap();
        map.put("askText",askText);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_PH, Const.ROUTING_KEY_PH, map);
        return "ok";
    }

    public String sendWaterMeter(String askText) {
        Map map = new HashMap();
        map.put("askText",askText);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_WATER_METER, Const.ROUTING_KEY_WATER_METER, map);
        return "ok";
    }

    public String sendElectricityMeter(String askText) {
        Map map = new HashMap();
        map.put("askText",askText);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_ELECTRICITY_METER, Const.ROUTING_KEY_ELECTRICITY_METER, map);
        return "ok";
    }
}
