package com.huimv.env.manage.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.manage.entity.EnvDeviceRegister;
import com.huimv.env.manage.saas.dao.entity.EnvDeviceEquipment;
import com.huimv.env.manage.saas.service.IEnvDeviceEquipmentService;
import com.huimv.env.manage.service.IEnvDeviceRegisterService;
import com.huimv.env.manage.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2022-08-18
 */
@RestController
@CrossOrigin
@RequestMapping("/envDeviceRegister")
public class EnvDeviceRegisterController {
    @Autowired
    private IEnvDeviceRegisterService deviceRegisterService;

    @Autowired
    private IEnvDeviceEquipmentService deviceEquipmentService;



    @PostMapping("/updateAllByUnitId")
    public Result updateAllByUnitId(@RequestBody Map<String,Integer> paramMap){
        return  deviceRegisterService.updateAllByUnitId(paramMap);

    }
    @PostMapping("/registerList")
    public Result registerList(@RequestBody Map<String,String> paramMap){
        return  deviceRegisterService.registerList(paramMap);

    }

    @PostMapping("/saveRegister")
    public Result saveRegister(@RequestBody Map<String,String> paramMap){
        return  deviceRegisterService.saveRegister(paramMap);
    }

    @PostMapping("/remove")
    public Result remove(@RequestBody Map<String,String> paramMap){
        String ids = paramMap.get("ids");
        String[] split = ids.split(",");
        for (String id : split) {
            EnvDeviceRegister byId = deviceRegisterService.getById(id);
            deviceEquipmentService.remove(new QueryWrapper<EnvDeviceEquipment>().eq("device_code", byId.getDeviceCode()));
            deviceRegisterService.removeById(id);
        }
        return new Result(10000,"删除成功",true) ;
    }



    @PostMapping("/lsitAllDeivce")
    public Result lsitAllDeivce(@RequestBody Map<String, String> map, HttpServletRequest request){
        return deviceRegisterService.lsitAllDeivce(map,request);

    }
    @PostMapping("/unbindingBaseDeviceCofig")
    public Result unbindingBaseDeviceCofig(@RequestBody Map<String, String> map, HttpServletRequest request){
        return deviceRegisterService.unbindingBaseDeviceCofig(map,request);

    }

    @PostMapping("/bindingBaseDeviceCofig")
    public Result bindingBaseDeviceCofig(@RequestBody Map<String, String> map, HttpServletRequest request){
        return deviceRegisterService.bindingBaseDeviceCofig(map,request);

    }


}
