package com.huimv.env.manage.controller;


import com.huimv.common.utils.Result;
import com.huimv.env.manage.service.EnvPhService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2022-10-26
 */
@RestController
@RequestMapping("/envPh")
@CrossOrigin
public class EnvPhController {
    @Resource
    public EnvPhService envPhService;

    /**
     * @Method      : getPh
     * @Description : 读取最新ph数值
     * @Params      : [paramsMap]
     * @Return      : com.huimv.common.utils.Result
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/10/26
     * @Time        : 13:56
     */
    @PostMapping("/getPh")
    public Result getPh(@RequestBody Map<String,String> paramsMap){
        return envPhService.getPh(paramsMap);
    }
    @PostMapping("/getPhList")
    public Result getPhList(@RequestBody Map<String,String> paramsMap){
        return envPhService.getPhList(paramsMap);
    }

}
