package com.huimv.env.manage.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.huimv.env.manage.entity.EnvSprayTime;
import com.huimv.env.manage.service.IEnvHumiService;
import com.huimv.env.manage.service.IEnvSprayTimeService;
import com.huimv.env.manage.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.CrossOrigin;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2022-08-18
 */
@RestController
@CrossOrigin
@RequestMapping("/envSprayTime")
public class EnvSprayTimeController {

    @Autowired
    private IEnvSprayTimeService envSprayTimeService;


    @PostMapping("/dataList")
    public Result registerList(@RequestBody Map<String,String> paramMap){
        return  envSprayTimeService.dataList(paramMap);

    }
    @PostMapping("/add")
    public Result add(@RequestBody EnvSprayTime envSprayTime){
        String openTime = envSprayTime.getOpenTime();
        String  closeTime= envSprayTime.getCloseTime();

       Integer duration  = (( Integer.parseInt(closeTime.substring(0,2)) -  Integer.parseInt(openTime.substring(0,2))) * 60*60)
                            + ((Integer.parseInt(closeTime.substring(3)) -Integer.parseInt(openTime.substring(3))) *60 );
        envSprayTime.setDuration(duration);
        List<EnvSprayTime> list = envSprayTimeService.list(new QueryWrapper<EnvSprayTime>().eq("device_code",envSprayTime.getDeviceCode()));
        envSprayTime.setOpenMode(list.get(0).getOpenMode());
        envSprayTimeService.save(envSprayTime);
        return  new Result(10000,"添加成功",false);

    }
    @PostMapping("/update")
    public Result update(@RequestBody EnvSprayTime envSprayTime){
        String openTime = envSprayTime.getOpenTime();
        String  closeTime= envSprayTime.getCloseTime();

        Integer duration  = (( Integer.parseInt(closeTime.substring(0,2)) -  Integer.parseInt(openTime.substring(0,2))) * 60*60)
                + ((Integer.parseInt(closeTime.substring(3)) -Integer.parseInt(openTime.substring(3))) *60 );
        envSprayTime.setDuration(duration);
        envSprayTimeService.updateById(envSprayTime);
        return  new Result(10000,"添加成功",false);

    }

    @PostMapping("/updateTime")
    public Result updateTime(@RequestBody Map<String,String> map){

        String deviceCode = map.get("deviceCode");
        String openTime = map.get("openTime");
        String closeTime = map.get("closeTime");
        UpdateWrapper<EnvSprayTime> wrapper = new UpdateWrapper<>();
        wrapper.eq("device_code",deviceCode);

       String openMode =  (Integer.parseInt(openTime)) +","+(Integer.parseInt(closeTime));
        EnvSprayTime envSprayTime = new EnvSprayTime();

        envSprayTime.setOpenMode(openMode);
        envSprayTimeService.update(envSprayTime,wrapper);

        return  new Result(10000,"添加成功",false);

    }


    @GetMapping("/delete")
    public Result delete(@RequestParam(name = "id") Integer id){
        envSprayTimeService.removeById(id);
        return  new Result(10000,"刪除成功",false);

    }
}
