package com.huimv.env.manage.controller;


import com.huimv.common.utils.Result;
import com.huimv.env.common.service.EnvWaterDayService;
import com.huimv.env.common.service.EnvWaterMonthService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-10-20`
 */
@RestController
@RequestMapping("/envWater")
@CrossOrigin
public class EnvWaterDayController {
    @Autowired
    private EnvWaterDayService envWaterDayService;
    @Resource
    private EnvWaterMonthService envWaterMonthService;

    @PostMapping("/getTodayWater")
    public Result getTodayWater(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return envWaterDayService.getTodayWater(paramsMap);
    }

    @PostMapping("/getDayAndMonthWaterList")
    public Result getDayAndMonthWaterList(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return envWaterMonthService.getDayAndMonthWaterList(paramsMap);
    }

    /**
     * @Method      : getWaterCount
     * @Description : 今天和本月用水量
     * @Params      : [paramsMap]
     * @Return      : com.huimv.common.utils.Result
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/10/28
     * @Time        : 9:26
     */
    @PostMapping("/getWaterCount")
    public Result getWaterCount(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return envWaterDayService.getWaterCount(paramsMap);
    }
}

