package com.huimv.env.manage.controller;

import com.alibaba.fastjson.JSONObject;
import com.huimv.env.manage.exception.ExceptionEnum;
import com.huimv.env.manage.exception.MiException;
import com.huimv.env.manage.token.*;

import com.huimv.env.manage.utils.Result;
import com.huimv.env.manage.utils.ResultCode;
import com.huimv.env.manage.utils.VerifyUtil;
import com.huimv.env.manage.entity.SysAccountMultilevel;
import com.huimv.env.manage.service.ILoginService;
import com.huimv.env.manage.session.AccessToken;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.Map;

@RestController
@CrossOrigin
@RequestMapping(value = "/my")
public class LoginController {



    @Autowired
    ILoginService iLoginService;



    @RequestMapping("/logout")
    public Result logout(@RequestParam(name = "accountName", required = true) String accountName, @RequestParam(name = "password", required = true) String password) {
        return iLoginService.logout();
    }


    @Autowired
    private RedisTemplate<String, String> redisTemplate;

    @GetMapping("/send")
    public void createImg(HttpServletRequest request, HttpServletResponse response)  {
        try {
            //设置响应类型,告诉浏览器输出的内容为图片
            response.setContentType("image/jpeg");
            //设置响应头信息，告诉浏览器不要缓存此内容
            response.setHeader("Pragma", "No-cache");
            response.setHeader("Cache-Control", "no-cache");
            response.setDateHeader("Expire", 0);
            VerifyUtil randomValidateCode = new VerifyUtil();
            //输出验证码图片
//            String code = randomValidateCode.getRandcode(request, response);
//            System.out.println(code);
            //将生成的随机验证码存放到redis中
//            String remoteHost = request.getRemoteHost();
//            redisTemplate.opsForValue().set(remoteHost,code,300, TimeUnit.SECONDS);
        } catch (Exception e) {
            System.out.println("获取验证码异常:"+e);
            throw new MiException(ExceptionEnum.VERIFCATION_FAID);
        }
    }

    //登录-多牧场
    @PostMapping(value = "/loginMultilevel")
    public Result loginMultilevel(HttpServletRequest req, @RequestBody Map<String, String> map)  {


        String accountName = map.get("accountName");
        String password = map.get("password");
//        String code = map.get("code");

        String remoteHost = req.getRemoteHost();

//        String redisCode = redisTemplate.opsForValue().get(remoteHost);
//        if (redisCode == null) {
//            return  new Result(10005,"验证码过期,点击刷新",false);
//        }
//        if (!redisCode.equals(code.toUpperCase())) {
//            return  new Result(10006,"验证码错误,登录失败",false);
//        }
        // 未对密码加密
        Result result = iLoginService.loginMultilevel(accountName, password);
        if(result.getCode() == 10000){

            SysAccountMultilevel accountEntity = (SysAccountMultilevel) result.getData();
            Integer id = accountEntity.getId();


            AccessToken accessToken = new AccessToken();
            accessToken.setCreated(new Date());
            accessToken.setAccountName(accountName);
            accessToken.setCode(result.getCode());
            accessToken.setMessage(result.getMessage());
            accessToken.setFarmId(accountEntity.getLastFarmId()+"");
            String token = TokenSign.sign(accountName,id,accountEntity.getFarmIds());
            accessToken.setToken(token);
            accessToken.setFarmName("慧牧测试牧场");
//            accessToken.setOpenId(accountEntity.getOpenId());
//            accessToken.setImgUrl(accountEntity.getImgUrl());
//            accessToken.setWechatName(accountEntity.getWechatName());

            accessToken.setId(id);
            accessToken.setLoginIp(remoteHost);
            accessToken.setType(accountEntity.getType());
            return new Result(ResultCode.SUCCESS,accessToken);
        }
        return  result;
    }

    //测试-token
    @GetMapping(value = "/getToken")
    public String getToken(HttpServletRequest req)  {
        String token =  TokenSign.sign("superadmin",1,null);
        return  token;
    }



    @Autowired
    private RestTemplate restTemplate;

    @GetMapping("/wechatLogin")
    public String wechatLogin(@RequestParam(name = "js_code")String js_code){
        String URL  = "https://api.weixin.qq.com/sns/jscode2session";
        String appid  = "wxa1289282dcd0746c";
        String secret  = "a9669fef70b7377b34d90e5d1643c5f4";
        String grant_type  = "authorization_code";

        String forObject = restTemplate.getForObject(URL + "?appid=" + appid + "&secret=" + secret + "&grant_type=" + grant_type + "&js_code=" + js_code, String.class);
        System.out.println(forObject);
        return forObject;

    }
}
