package com.huimv.env.manage.saas.controller;


import com.huimv.env.manage.saas.dao.entity.EnvDeviceEquipment;
import com.huimv.env.manage.saas.service.IEnvDeviceEquipmentService;
import com.huimv.env.manage.service.IEnvDeviceRegisterService;
import com.huimv.env.manage.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 环控绑定设备 前端控制器
 * </p>
 *
 * @author author
 * @since 2022-10-18
 */
@RestController
@RequestMapping("/envDeviceEquipment")
public class EnvDeviceEquipmentController {

    @Autowired
    IEnvDeviceRegisterService deviceRegisterService;

    @Autowired
    IEnvDeviceEquipmentService envDeviceEquipmentService;

    @PostMapping("/listByUnit")
    public Result listByUnit(@RequestBody Map<String, String> map, HttpServletRequest request){

        return deviceRegisterService.listByUnit(map,request);
    }

    @PostMapping("/update")
    public Result update(@RequestBody EnvDeviceEquipment envDeviceEquipment){
        try {
            envDeviceEquipmentService.updateById(envDeviceEquipment);
            return new Result(10000,"修改成功",true);
        }catch (Exception e){
            return new Result(10001,"修改失败",false);
        }


    }


    @PostMapping("/remove")
    public Result remove(@RequestBody Map<String, String> map){
        try {
            String id = map.get("id");
            envDeviceEquipmentService.removeById(id);
            return new Result(10000,"删除成功",true);
        }catch (Exception e){
            return new Result(10001,"删除失败",false);
        }


    }

    /**
     * @Method      : getEquipment
     * @Description :
     * @Params      : [farmCode,binding]
     * @Return      : com.huimv.common.utils.Result
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/10/27
     * @Time        : 17:54
     */
    @PostMapping("/getEquipment")
    public com.huimv.common.utils.Result getEquipment(@RequestBody Map<String,String> paramsMap){
        return envDeviceEquipmentService.getEquipment(paramsMap);
    }

    /**
     * @Method      : getShowRoomEquipment
     * @Description :
     * @Params      : [unitId,binding]
     * @Return      : com.huimv.common.utils.Result
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/10/27
     * @Time        : 18:09
     */
    @PostMapping("/getShowRoomEquipment")
    public com.huimv.common.utils.Result getShowRoomEquipment(@RequestBody Map<String,String> paramsMap){
        return envDeviceEquipmentService.getShowRoomEquipment(paramsMap);
    }

    /**
     * @Method      : setEquipmentStatus
     * @Description :
     * @Params      : [farmCode,deviceCode,port,status]
     * @Return      : com.huimv.common.utils.Result
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/10/27
     * @Time        : 17:55
     */
    @PostMapping("/setEquipmentStatus")
    public com.huimv.common.utils.Result setEquipmentStatus(@RequestBody Map<String,String> paramsMap){
        return envDeviceEquipmentService.setEquipmentStatus(paramsMap);
    }

    /**
     * @Method      : setShowRoomEquipmentStatus
     * @Description : 
     * @Params      : [id,status]
     * @Return      : com.huimv.common.utils.Result
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/10/27       
     * @Time        : 19:01
     */
    @PostMapping("/setShowRoomEquipmentStatus")
    public com.huimv.common.utils.Result setShowRoomEquipmentStatus(@RequestBody Map<String,String> paramsMap){
        return envDeviceEquipmentService.setShowRoomEquipmentStatus(paramsMap);
    }
}
