package com.huimv.env.manage.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.env.manage.entity.EnvPushMessage;
import com.huimv.env.manage.mapper.EnvPushMessgeMapper;
import com.huimv.env.manage.service.IEnvPushMessgeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.env.manage.utils.Result;
import com.huimv.env.manage.utils.ResultCode;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2022-08-18
 */
@Service
public class EnvPushMessgeServiceImpl extends ServiceImpl<EnvPushMessgeMapper, EnvPushMessage> implements IEnvPushMessgeService {

    @Override
    public Result listMessge(Map<String, String> paramMap) {
        String farmCode = paramMap.get("farmCode");
        String pageSize = paramMap.get("pageSize");
        String pageNum = paramMap.get("pageNum");
        QueryWrapper<EnvPushMessage> wrapper = new QueryWrapper<>();

        wrapper.eq("farm_code",farmCode);
        wrapper.eq("display",1);
        wrapper.orderByAsc("read_status");
        wrapper.orderByDesc("add_time");
        IPage<EnvPushMessage> page = this.page(new Page<>( Long.parseLong(pageNum),Long.parseLong(pageSize)),wrapper);
        return new Result(ResultCode.SUCCESS,page);
    }

    @Override
    public Result countRead(Integer farmCode) {
        QueryWrapper<EnvPushMessage> wrapper = new QueryWrapper<>();

        wrapper.eq("display",1);
        long count = this.count(wrapper);
        wrapper.eq("read_status",0);
        long count1 = this.count(wrapper);
        Map map = new HashMap();
        map.put("read",count -count1);
        map.put("all",count );
        map.put("noRead",count1);
        return new Result(ResultCode.SUCCESS,map);
    }
}
