package com.huimv.env.manage.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.manage.entity.EnvConfig;
import com.huimv.env.manage.entity.EnvDeviceRegister;
import com.huimv.env.manage.entity.EnvSprayConfig;
import com.huimv.env.manage.entity.EnvSprayTime;
import com.huimv.env.manage.mapper.EnvConfigMapper;
import com.huimv.env.manage.mapper.EnvSprayConfigMapper;
import com.huimv.env.manage.mapper.EnvSprayTimeMapper;
import com.huimv.env.manage.service.IEnvDeviceRegisterService;
import com.huimv.env.manage.service.IEnvSprayConfigService;
import com.huimv.env.manage.service.IEnvSprayTimeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.env.manage.utils.Result;
import com.huimv.env.manage.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2022-08-18
 */
@Service
public class EnvSprayTimeServiceImpl extends ServiceImpl<EnvSprayTimeMapper, EnvSprayTime> implements IEnvSprayTimeService {

    @Autowired
    private EnvSprayConfigMapper envSprayConfigMapper;

    @Autowired
    private EnvConfigMapper  envConfigMapper;
    @Override
    public Result dataList(Map<String, String> paramMap) {
        String deviceCode = paramMap.get("deviceCode");
        String farmCode = paramMap.get("farmCode");
        EnvSprayConfig deviceRegister = envSprayConfigMapper.selectOne(new QueryWrapper<EnvSprayConfig>().eq("device_code", deviceCode));

        List<EnvSprayTime> envSprayTimes = this.list(new QueryWrapper<EnvSprayTime>().eq("device_code", deviceCode));
        List<EnvConfig> envConfigs = envConfigMapper.selectList(new QueryWrapper<EnvConfig>().eq("farm_code", farmCode));
        Map endMap = new HashMap();
        endMap.put("runMode",deviceRegister.getRunMode());
        endMap.put("envSprayTimes",envSprayTimes);
        endMap.put("envConfigs",envConfigs);

        return new Result(ResultCode.SUCCESS,endMap);
    }
}
