package com.huimv.env.produce.controller;


import com.alibaba.fastjson.JSONObject;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.env.produce.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-11-01
 */
@RestController
@RequestMapping("/v1.0.0/board")
public class BoardController {
    @Autowired
    private WarningInfoService warningInfoService;
    @Autowired
    private TuppingService tuppingService;
    @Autowired
    private BirthService birthService;
    @Autowired
    private WeanService weanService;
    @Autowired
    private WorkplanService workplanService;
    @Autowired
    private TransferService transferService;
    @Autowired
    private GeneralImmunityPlanService generalImmunityPlanService;
    @Autowired
    private SpecialImmunityPlanService specialImmunityPlanService;
    @Autowired
    private BoardService boardService;

    @PostMapping("/getBoardCount_old1")
    public Result getCount_old(@RequestBody Map<String, String> paramsMap) throws ParseException {
        JSONObject resultJo = new JSONObject();
        resultJo.put("warningCount",warningInfoService.getWarningCount(paramsMap));
        resultJo.put("tuppingCount",tuppingService.getTuppingCount(paramsMap));
        resultJo.put("birthCount",birthService.getBirthCount(paramsMap));
        resultJo.put("weanCount",weanService.getWeanCount(paramsMap));
        resultJo.put("workplanCount",workplanService.getWorkplanCount(paramsMap));
        resultJo.put("transferCount",transferService.getTransferCount(paramsMap));
        resultJo.put("generalImmunityCount",generalImmunityPlanService.getGeneralImmunityCount(paramsMap));
        resultJo.put("specialImmunityCount",specialImmunityPlanService.getSpecialImmunityCount(paramsMap));
        return new Result(ResultCode.SUCCESS,resultJo);
    }

    @PostMapping("/getBoardCount")
    public Result getCount(@RequestBody Map<String, String> paramsMap) throws ParseException {
        return boardService.getBoardCount(paramsMap);
    }

    @PostMapping("/save")
    public Result save(@RequestBody Map<String, String> paramsMap) throws ParseException {
        return boardService.save(paramsMap);
    }
}

