package com.huimv.env.produce.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.common.utils.DateUtil;
import com.huimv.env.produce.entity.Birth;
import com.huimv.env.produce.entity.Tupping;
import com.huimv.env.produce.mapper.BirthMapper;
import com.huimv.env.produce.mapper.TuppingMapper;
import com.huimv.env.produce.service.BirthService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-10-30
 */
@Service
public class BirthServiceImpl extends ServiceImpl<BirthMapper, Birth> implements BirthService {
    @Autowired
    private BirthMapper birthMapper;

    @Override
    public Object getBirthCount(Map<String, String> paramsMap) {
        String farmCode = paramsMap.get("farmCode");
        QueryWrapper<Birth> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_code",farmCode);
        queryWrapper.eq("process_state",0);
        queryWrapper.orderByDesc("add_date");
        return birthMapper.selectCount(queryWrapper);
    }
}
