package com.huimv.env.produce.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.env.common.utils.DateUtil;
import com.huimv.env.produce.entity.Indicator;
import com.huimv.env.produce.mapper.IndicatorMapper;
import com.huimv.env.produce.service.IndicatorService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-10-30
 */
@Service
public class IndicatorServiceImpl extends ServiceImpl<IndicatorMapper, Indicator> implements IndicatorService {
    @Autowired
    private IndicatorMapper indicatorMapper;

    @Override
    public Result getIndicator(Map<String, String> paramsMap) {
        DateUtil dateUtil = new DateUtil();
        String farmCode = paramsMap.get("farmCode");
        QueryWrapper<Indicator> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_code",farmCode);
        queryWrapper.eq("year",dateUtil.getThisYear());
        queryWrapper.eq("month",dateUtil.getThisMonth());
        return new Result(ResultCode.SUCCESS,indicatorMapper.selectList(queryWrapper));
    }

    @Override
    public Result list(Map<String, String> paramsMap) {
        String farmCode = paramsMap.get("farmCode");
        QueryWrapper<Indicator> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_code",farmCode);
        return new Result(ResultCode.SUCCESS,indicatorMapper.selectList(queryWrapper));
    }

    @Override
    public Result add(Map<String, String> paramsMap) {
        return null;
    }

    @Override
    public Result edit(Map<String, String> paramsMap) {
        return null;
    }

    @Override
    public Result remove(Map<String, String> paramsMap) {
        return null;
    }
}
