package com.huimv.env.produce.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.common.utils.DateUtil;
import com.huimv.env.produce.entity.Transfer;
import com.huimv.env.produce.entity.Workplan;
import com.huimv.env.produce.mapper.TransferMapper;
import com.huimv.env.produce.service.TransferService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-10-30
 */
@Service
public class TransferServiceImpl extends ServiceImpl<TransferMapper, Transfer> implements TransferService {
    @Autowired
    private TransferMapper transferMapper;

    @Override
    public Object getTransferCount(Map<String, String> paramsMap) {
        DateUtil dateUtil = new DateUtil();
        String farmCode = paramsMap.get("farmCode");
        QueryWrapper<Transfer> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_code",farmCode);
        queryWrapper.eq("year",dateUtil.getThisYear());
        queryWrapper.orderByDesc("add_date");
//        queryWrapper.eq("add_date",dateUtil.getTodayDate());
        return transferMapper.selectCount(queryWrapper);
    }
}
