package com.huimv.env.produce.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.env.common.utils.DateUtil;
import com.huimv.env.produce.entity.Tupping;
import com.huimv.env.produce.entity.WarningInfo;
import com.huimv.env.produce.mapper.TuppingMapper;
import com.huimv.env.produce.service.TuppingService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-10-30
 */
@Service
public class TuppingServiceImpl extends ServiceImpl<TuppingMapper, Tupping> implements TuppingService {
    @Autowired
    private TuppingMapper tuppingMapper;

    @Override
    public Object getTuppingCount(Map<String, String> paramsMap) throws ParseException {
        String farmCode = paramsMap.get("farmCode");
        QueryWrapper<Tupping> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_code",farmCode);
        queryWrapper.eq("process_state",0);
        queryWrapper.orderByDesc("add_date");
        return tuppingMapper.selectCount(queryWrapper);
    }

    @Override
    public Result list(Map<String, String> paramsMap) {
        //pageNo
        String pageNo = "1";
        if (StringUtils.isBlank(paramsMap.get("pageNo") + "")){
            pageNo = paramsMap.get("pageNo") + "";
        }
        //pageSize
        String pageSize = "10";
        if (StringUtils.isBlank(paramsMap.get("pageSize") + "")) {
            pageSize = paramsMap.get("pageSize") + "";
        }
        //
        String farmCode = paramsMap.get("farmCode");
        QueryWrapper<Tupping> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_code",farmCode);
        queryWrapper.orderByDesc("add_date").orderByDesc("id");
        queryWrapper.last("LIMIT 1");
        Page<Tupping> page = new Page<>(Integer.parseInt(pageNo), Integer.parseInt(pageSize));
        return new Result(ResultCode.SUCCESS, tuppingMapper.selectPage(page, queryWrapper));
    }

    @Override
    public Result add(Map<String, String> paramsMap) {
        Tupping tupping = new Tupping();
        tuppingMapper.insert(tupping);
        return null;
    }

    @Override
    public Result edit(Map<String, String> paramsMap) {
        return null;
    }

    @Override
    public Result remove(Map<String, String> paramsMap) {
        return null;
    }
}
