package com.huimv.env.produce.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.common.utils.DateUtil;
import com.huimv.env.produce.entity.Birth;
import com.huimv.env.produce.entity.Wean;
import com.huimv.env.produce.mapper.WeanMapper;
import com.huimv.env.produce.service.WeanService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-10-30
 */
@Service
public class WeanServiceImpl extends ServiceImpl<WeanMapper, Wean> implements WeanService {
    @Autowired
    private WeanMapper weanMapper;

    @Override
    public Object getWeanCount(Map<String, String> paramsMap) {
        DateUtil dateUtil = new DateUtil();
        String farmCode = paramsMap.get("farmCode");
        QueryWrapper<Wean> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_code",farmCode);
        queryWrapper.eq("process_state",0);
        queryWrapper.orderByDesc("add_date");
//        queryWrapper.eq("add_date",dateUtil.getTodayDate());
        return weanMapper.selectCount(queryWrapper);
    }
}
